/***************************************************************************
 *   Copyright (C) 2007 by Tobias Schwarz   *
 *   mail@tobias-schwarz.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   In addition, as a special exception, the copyright holders give       *
 *   permission to link the code of this program with any edition of       *
 *   the Qt library by Trolltech AS, Norway (or with modified versions     *
 *   of Qt that use the same license as Qt), and distribute linked         *
 *   combinations including the two.  You must obey the GNU General        *
 *   Public License in all respects for all of the code used other than    *
 *   Qt.  If you modify this file, you may extend this exception to        *
 *   your version of the file, but you are not obligated to do so.  If     *
 *   you do not wish to do so, delete this exception statement from        *
 *   your version.                                                         *
 ***************************************************************************/

#ifndef KEMBOSS_H
#define KEMBOSS_H

#include "kembossWindowClass.h"
#include "programWindowClass.h"
#include "settings.h"
#include "ui_kemboss.h"

class kemboss : public kembossWindow, private Ui::kemboss
{
   Q_OBJECT

public:
   kemboss(kembossWindow *parent = 0);
   QList<kembossWindow *> programWindows;
   kembossSettings ksettings;
   void loadLists(const bool phylipnew);

protected:
   void closeEvent(QCloseEvent *event);

private slots:
   void on_actionCloseAll_triggered();
   void on_PreferencesPushButton_clicked();
   void on_RunProgramPushButton_clicked();
   void on_actionEmbossHelp_triggered();
   void on_SearchByKeywordPushButton_clicked();

private:
   bool loadFile(const QString &fileName);
   bool saveFile(const QString &fileName);
   bool maybeSave();
   void setCurrentFile(const QString &fileName);
   void createProgramTree(const QString &programsFile);
   void createProgramList(const QString &programsFile);
   kprogramWindow* createProgramWindow(const QString &newProgram);
   QString selectedProgram();
};

#endif
